<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: gpgupload.php,v 1.14 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_FILES['gfile']['size']))     { $gfile_size  = $_FILES['gfile']['size']; }     else { $gfile_size  = NULL; }
if (isset($_FILES['gfile']['name']))     { $gfile_name  = $_FILES['gfile']['name']; }     else { $gfile_name  = NULL; }
if (isset($_FILES['gfile']['tmp_name'])) { $gfile       = $_FILES['gfile']['tmp_name']; } else { $gfile       = NULL; }
if (isset($_FILES['gfile']['type']))     { $gfile_type  = $_FILES['gfile']['type']; }     else { $gfile_type  = NULL; }
if (isset($_FILES['gfile']['error']))    { $gfile_error = $_FILES['gfile']['error']; }    else { $gfile_error = NULL; }

d_StartPage(gettext("Upload GPG/PGP Keyfile"));
d_DrawNav($_USER['uname']);
d_DrawHeader(gettext("Upload GPG/PGP Keyfile"));

if ($gfile == "none")
{
    print("<p>" . gettext("No keyfile uploaded.") . "</p>");
    d_DrawFooter();
    exit;
}
if ($gfile_size == 0)
{
    print("<p>" . gettext("The keyfile uploaded is zero bytes.") . "</p>");
    d_DrawFooter();
    exit;
}
if (!is_uploaded_file($gfile))
{
    print("<p>" . gettext("The keyfile was not uploaded... possible file upload attack?") . "</p>");
    d_DrawFooter();
    exit;
}

$newfile = $_CONF['root'] . $_CONF['gpgdir'] . "/" . $_USER['uid'] . ".asc";

print("<p>" . gettext("Keyfile uploaded successfully!") . "</p>");

/// read in the keyfile
$fp   = fopen($gfile, "r");
$data = fread($fp, filesize($gfile));
fclose($fp);

// let's make sure it's a valid PGP/GPG key first
if (ereg("^-----BEGIN PGP PUBLIC KEY BLOCK-----",$data))
{
    if (ereg("-----END PGP PUBLIC KEY BLOCK-----",$data, $array))
    {
        $valid = 1;
    } else {
        $valid = 0;
    }
} else {
    $valid = 0;
}

if ($valid == 0)
{
    print("<p><font color=\"red\">" . gettext("The file you uploaded is not a valid PGP/GPG key file.") . "</font></p>");
} else {
    $data = strip_tags($data);
    print("<p>" . gettext("The keyfile uploaded contains") . ":</p>");
    print("<pre>" . $data . "</pre>");

    // write the keyfile
    $fp   = fopen($newfile, "w");
    fwrite($fp, $data);
    fclose($fp);
    $gname  = $_CONF['gpgdir'] . "/" . $_USER['uid'] . ".asc";
    $result = $db->query("UPDATE users SET gpg = '$gname' WHERE uid = '" . $_USER['uid'] . "'");
    dberror($result);
}

print("<p><a href=\"pref.php\">" . gettext("Return to Preferences") . "</a></p>");

d_DrawFooter();

?>
